// Filename: router.js
define(function (require) {
    //Others
    var $ =                         require('jquery'),
        _ =                         require('underscore'),
        Backbone =                  require('backbone'),
        main =                      require('main2'),
        //USER
        UserHomeView =              require('views/user/UserHomeView'),
        UserAlbumView =             require('views/user/UserAlbumView'),
        UserAlbumsView =            require('views/user/UserAlbumsView'),
        UserAboutUsView =           require('views/user/UserAboutUsView'),
        UserHowItWorksView =             require('views/user/UserHowItWorksView'),
        UserDataUsePolicyView =     require('views/user/UserDataUsePolicyView'),
        //SHOP
        ShopProductsView =          require('views/shop/ShopProductsView'),
        ShopProductView =           require('views/shop/ShopProductView'),
        ShopBasketView =            require('views/shop/ShopBasketView'),
        //COMPANY
        CompanyLoginView =          require('views/company/CompanyLoginView'),
        CompanyRegisterView =       require('views/company/CompanyRegisterView'),
        CompanyHomeView =           require('views/company/CompanyHomeView'),
        CompanyLogoutView =         require('views/company/CompanyLogoutView'),
        CompanyProductsView =       require('views/company/CompanyProductsView'),
        CompanyProductsAddView =    require('views/company/CompanyProductsAddView'),
        CompanyProductsEditView =   require('views/company/CompanyProductsEditView'),
        CompanyProductsPhotosView = require('views/company/CompanyProductsPhotosView'),
        CompanyProfileView =        require('views/company/CompanyProfileView'),
        CompanyLogosView =          require('views/company/CompanyLogosView'),
        CompanyPhotosView =         require('views/company/CompanyPhotosView'),
        CompanyDataView =           require('views/company/CompanyDataView'),
        CompanySalesView =          require('views/company/CompanySalesView'),
        CompanyStatisticsView =     require('views/company/CompanyStatisticsView');

    var AppRouter = Backbone.Router.extend({
        routes: {
            //USER
            'albums': 'UserAlbumsView',
            'album/:id': 'UserAlbumView',
            'aboutus': 'UserAboutUsView',
            'howitworks': 'UserHowItWorksView',
            'datausepolicy': 'UserDataUsePolicyView',
            //SHOP
            'shop': 'ShopProductsView',
            'shop/products': 'ShopProductsView',
            'shop/products/:id': 'ShopProductView',
            'shop/basket': 'ShopBasketView',
            //COMPANY
            'company': 'CompanyLoginView',
            'company/logout': 'CompanyLogoutView',
            'company/register': 'CompanyRegisterView',
            'company/home': 'CompanyHomeView',
            'company/products': 'CompanyProductsView',
            'company/products/add': 'CompanyProductsAddView',
            'company/products/edit/:id': 'CompanyProductsEditView',
            'company/products/:id/photos': 'CompanyProductsPhotosView',
            'company/photos': 'CompanyPhotosView',
            'company/data': 'CompanyDataView',
            'company/sales': 'CompanySalesView',
            'company/statistics': 'CompanyStatisticsView',
            'company/profile': 'CompanyProfileView',
            'company/logos': 'CompanyLogosView',

            //Defaults
            'shop/*path': 'ShopProductsView', //Default for company/*
            'company/*path': 'CompanyHomeView', //Default for company/*
            '*actions': 'UserHomeView'// Default for everything
        }
    });

    var initialize = function () {
        var app_router = new AppRouter;
        //USER
        app_router.on('route:UserHomeView', function () {new UserHomeView().render();});
        app_router.on('route:UserAlbumsView', function () {new UserAlbumsView().render();});
        app_router.on('route:UserAlbumView', function (id) {new UserAlbumView(id).render();});
        app_router.on('route:UserAboutUsView', function () {new UserAboutUsView().render();});
        app_router.on('route:UserHowItWorksView', function () {new UserHowItWorksView().render();});
        app_router.on('route:UserDataUsePolicyView', function () {new UserDataUsePolicyView().render();});

        //SHOP
        app_router.on('route:ShopProductsView', function () {new ShopProductsView().render(); });
        app_router.on('route:ShopProductView', function (id) {new ShopProductView(id).render(); });
        app_router.on('route:ShopBasketView', function () {new ShopBasketView().render(); });

        //COMPANY
        app_router.on('route:CompanyLoginView', function () {new CompanyLoginView().render();});
        app_router.on('route:CompanyRegisterView', function () { new CompanyRegisterView().render();});
        app_router.on('route:CompanyHomeView', function () {new CompanyHomeView().render();});
        app_router.on('route:CompanyLogoutView', function () {new CompanyLogoutView().render(); });
        app_router.on('route:CompanyProductsView', function () {new CompanyProductsView().render();});
        app_router.on('route:CompanyProductsAddView', function () {new CompanyProductsAddView().render(); });
        app_router.on('route:CompanyProductsEditView', function (id) {new CompanyProductsEditView(id).render();});
        app_router.on('route:CompanyProductsPhotosView', function (id) {new CompanyProductsPhotosView(id).render(); });
        app_router.on('route:CompanyProfileView', function () { new CompanyProfileView().render();});
        app_router.on('route:CompanyLogosView', function () {new CompanyLogosView().render();});
        app_router.on('route:CompanyPhotosView', function () {new CompanyPhotosView().render();});
        app_router.on('route:CompanyDataView', function () {new CompanyDataView().render();});
        app_router.on('route:CompanyStatisticsView', function () {new CompanyStatisticsView().render();});
        app_router.on('route:CompanySalesView', function () {new CompanySalesView().render();});

        Backbone.history.start();
    };
    return { initialize: initialize};
});