define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2','alertify',
        'text!templates/company/loginTemplate.html'

    ],
    function ($, cookie, _, Backbone, main, alertify, template) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
            },
            events: {"click .login": "onSubmit"},
            onSubmit: function (e) {
                e.preventDefault();

                var login = new Backbone.Model({
                    email: this.$("#email").val(),
                    password: this.$("#password").val()
                });

                login.save({}, {
                    url: "/company/login",
                    success: function (model, response) {
                        console.log(response);
                        $.cookie("photopotterAuth", true, { expires: 30 });
                        window.location = "/#company/home";
                    },
                    error: function (model, response) {
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error)
                    },
                    wait: true // Add this
                });
            },

            render: function () {
                if ($.cookie("photopotterAuth"))
                {
                    initMenuCompany("#menu-homeCompany");
                    window.location = "/#company/home";
                }
                else {
                    $("#content").html(template);
                    $("#email").focus();
                    clearMenu();
                }
            }
        });
    });
