define([
        'jquery', 'jquerycookie', 'alertify','underscore', 'backbone'
    ],
    function ($, cookie, alertify, _, Backbone) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
            },
            render: function () {

                if (!$.cookie("photopotterAuth"))window.location = "/#company";
                else {
                    var LogoutModel = Backbone.Model.extend({
                        url: function () {
                            return '/company/logout';
                        },
                        parse: function (res) {
                            // because of jsonp
                            return res.data;
                        }
                    });
                    this.model = new LogoutModel();
                    this.model.save({}, {
                        success: function (model, response) {
                            console.log(response);
                            alertify.success("Session closed");
                            $.removeCookie("photopotterAuth");
                            window.location = "/#company";
                        },
                        error: function (model, response) {
                            console.log(response);
                            alertify.success("Session closed");
                            $.removeCookie("photopotterAuth");
                            window.location = "/#company";
                        }

                    });
                }
            }
        });
    });
