define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2','alertify',
        'text!templates/company/productsAddTemplate.html',
        'models/company/ProductModel'
    ],
    function ($, cookie, _, Backbone, main, alertify,template, ProductModel) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
            },
            events: {"click .addProduct": "onSubmit"},
            onSubmit: function (e) {
                getTarget(e).disabled = true;
                getTarget(e).innerHTML = "Adding...";
                e.preventDefault();

                var data = {
                    name: this.$("#name").val(),
                    description: this.$("#description").val(),
                    t_description: this.$("#t_description").val(),
                    category: this.$("#category").val(),
                    coins: this.$("#coins").val(),
                    quantity: this.$("#quantity").val()
                };

                this.model = new ProductModel(data);
                this.model.save({}, {
                    success: function (model, response) {
                        console.log(response);
                        window.location = "/#company/products/edit/"+response.id;
                        alertify.success("Product added! Now you can upload product photos");

                    },
                    error: function (model, response) {
                        var responseObj = $.parseJSON(response.responseText);
                        alertify.error(responseObj.error);
                        getTarget(e).disabled = false;
                        getTarget(e).innerHTML = "Add";
                    }
                });
            },
            render: function () {
                if (!$.cookie("photopotterAuth"))window.location = "/#company";
                else {
                    var data = {
                        type: "Add",
                        product: [],
                        _: _
                    };
                    var compiledTemplate = _.template(template, data);
                    $("#content").html(compiledTemplate);
                    $("#name").focus();
                    initMenuCompany("#menu-products");
                }
            }
        });
    });