define([
        'jquery', 'jquerycookie', 'underscore', 'backbone',
        'main2','alertify',
        'text!templates/company/registerTemplate.html',
        'models/company/CompanyModel'
    ],
    function ($, cookie, _, Backbone, main, alertify,template, CompanyModel) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
                var that = this;

                that.collection = new CompanyModel([]);
                that.collection.fetch({
                    success: function (collection, response) {
                        console.log(response);
                        that.collection = response;
                        that.render2();
                    },
                    error: function (collection, response) {
                        console.log("ERROR");
                    }});
            },
            events: {"click .register": "onSubmit"},
            onSubmit: function (e) {
                e.preventDefault();
                if (this.$("#password").val() != this.$("#password2").val()) alertify.error("Different passwords");
                else {
                    var data = {
                        id: this.collection.id,
                        name: this.$("#name").val(),
                        type: this.$("#type").val(),
                        street: this.$("#street").val(),
                        city: this.$("#city").val(),
                        country: this.$("#country").val(),
                        postcode: this.$("#postcode").val(),
                        email: this.$("#email").val(),
                        password: this.$("#password").val(),
                        oldpassword: this.$("#oldpassword").val()
                    };

                    this.model = new CompanyModel(data);
                    console.log(data);
                    this.model.save({}, {
                        success: function (model, response) {
                            console.log(response);
                            alertify.success("Profile updated!");
                        },
                        error: function (model, response) {
                            console.log(response);
                            var responseObj = $.parseJSON(response.responseText);
                            alertify.error(responseObj.error);
                        }
                    });
                }
            },
            render2: function () {
                if (!$.cookie("photopotterAuth"))window.location = "/#company";
                else {
                    if (this.collection) {
                        var data = {
                            type: "Update",
                            profile: this.collection,
                            _: _
                        };
                        var compiledTemplate = _.template(template, data);
                        $("#content").html(compiledTemplate);
                        $("#name").focus();
                    }
                    initMenuCompany("#menu-profile");
                }
            }
        });
    });