define([
    'jquery',
    'underscore',
    'backbone',
    'models/shop/ShopBasketLineModel'
], function ($, _, Backbone, ShopBasketLineModel) {

    return Backbone.View.extend({
        el: $("#basket"),
        initialize: function (attrs) {
            $(this.el).unbind("click");
            var that = this;
            that.id = attrs;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    that.basketline = new ShopBasketLineModel({userID: response.authResponse.accessToken });
                    that.basketline.fetch({
                        success: function (model, response) {
                            that.total = 0;
                            that.totalVisuals = 0;
                            for (var i = 0; i < response.length; i++) {
                                that.total += response[i].quantity;
                                that.totalVisuals += response[i].quantity * response[i].product2.coins;
                            }
                            that.render2();
                        },
                        error: function (model, response) {
                            console.log("ERROR");
                            console.log(response);
                        }});
                }
            });
        },
        render2: function () {
           // $("#basket").html(this.total);
            if(this.totalVisuals>0)$("#basketVisuals").html(this.totalVisuals+" Visuals <img src='../../imgs/shopping_cart2.png'>");
            else $("#basketVisuals").html("0 Visuals <img src='../../imgs/shopping_cart.png'>");
        }
    });
});