define([
    'jquery',
    'underscore',
    'backbone',
    'main2','alertify','jqueryfbp',
    'text!templates/shop/productTemplate.html',
    'models/user/UserModel',
    'models/shop/ShopBasketLineModel',
    'views/shop/ShopBasketSubView',
    'views/user/UserVisualsFriendsSubView'
], function ($, _, Backbone, main2,alertify, fb1, template,UserModel, ShopBasketLineModel, ShopBasketSubView,   UserVisualsFriendsSubView){

    return Backbone.View.extend({
        el: $("#content"),

        initialize: function (attrs) {
            $(this.el).unbind("click");
            console.log(attrs);
            var that=this;
            that.id = attrs;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    that.product = new Backbone.Model();
                    that.product.fetch({
                        url: "/user/"+response.authResponse.accessToken+"/shop/product/"+that.id,
                        success: function (model, response) {
                            if(response.length>0) {
                                console.log(response);
                                that.collection = response;
                                that.fetchBasketLine(response);
                            }
                        },
                        error: function (model, response) {
                            console.log(response);
                           console.log("error");
                        }});
                }
                else window.location = "/";
            });
        },
        fetchBasketLine: function(product){
            console.log(product[0].id);
            var that=this;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    that.basketline = new ShopBasketLineModel({userID: response.authResponse.accessToken, id: product[0].id });
                    that.basketline.fetch({
                        success: function (model, response) {
                            console.log(response);
                            if(response.length>0) {
                                that.collection[0]['basket_quantity'] = response[0].quantity;
                                that.collection[0]['basket_description'] = response[0].description;
                            }
                            that.render2();
                        },
                        error: function (model, response) {
                            console.log("ERROR");
                            console.log(response);
                        }});
                }
                else window.location = "/";
            });
        },
        events: {"click .addBasket": "addBasket"},
        addBasket: function (e) {
            e.preventDefault();
            var that = this;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    that.product = new ShopBasketLineModel({
                        idProduct: getTarget(e).id,
                        userID:response.authResponse.accessToken ,
                        quantity:this.$("#quantity").val(),
                        description:this.$("#description").val()}
                );

                    that.product.save({}, {
                        success: function ( model,response) {
                            alertify.success("Product added!");
                            console.log(response);
                            new ShopBasketSubView();
                        },
                        error: function (model, response) {
                            alertify.error($.parseJSON(response.responseText).error);
                            console.log(response);
                        }});
                }
            });
        },
        render2: function () {
            initMenuUser("#menu-shop");
            new ShopBasketSubView();
            var data = {
                product: this.collection[0],
                _: _
            };
            console.log(data);
            var compiledTemplate = _.template(template, data);
            $("#content").html(compiledTemplate);
            $(".fancybox").fancybox(initFancyBox);
            new UserVisualsFriendsSubView();
        }
    });
});