define([
        'jquery',
        'underscore',
        'backbone',
        'main2',
        'text!templates/shop/productsTemplate.html',
        'models/user/UserModel',
        'views/shop/ShopBasketSubView',
        'views/user/UserVisualsFriendsSubView',
        'views/shop/ShopProductsListView'
    ],
    function ($, _, Backbone, main, template, UserModel, ShopBasketSubView, UserVisualsFriendsSubView, ShopProductsListView) {

        return Backbone.View.extend({
            el: $("#content"),
            initialize: function () {
                $(this.el).unbind("click");
                var that = this;
                FB.getLoginStatus(function (response) {
                    if (response.status === 'connected') {
                        that.product = new Backbone.Model();
                        that.product.fetch({
                            url: "/user/" + response.authResponse.accessToken + "/shop/products/",
                            success: function (model, response) {
                                console.log(response);
                                that.collection = response;
                                that.render2();
                            },
                            error: function (model, response) {
                                console.log("ERROR");
                            }});
                    }
                    else window.location = "/";
                });
            },
            events: {"click .category": "loadCategory"},
            loadCategory: function (e) {
                console.log(1);
                e.preventDefault();
                var that = this;
                FB.getLoginStatus(function (response) {
                    if (response.status === 'connected') {
                        console.log(3);
                        $(getTarget(e).parentNode).children().removeClass("current");
                        $(getTarget(e)).addClass("current");
                        var category = getTarget(e).text;
                        if (category === "All Categories") category = "";
                        that.product = new Backbone.Model();
                        that.product.fetch({
                            url: "/user/" + response.authResponse.accessToken + "/shop/products/" + category,
                            success: function (model, response) {
                                console.log(response);
                                that.collection = response;
                                that.render2();
                            },
                            error: function (model, response) {
                                console.log("error");
                            }});
                    }
                });
            },
            render: function () {
                new ShopBasketSubView();
                new UserVisualsFriendsSubView();
                initMenuUser("#menu-shop");
                $("#content").html(template);
            },
            render2: function () {
                var products;
                if (this.collection.length>0) products = new ShopProductsListView({ collection: this.collection});
                else products = new ShopProductsListView({ collection: []});
                products.render();
            }
        });
    });