define([
    'jquery',
    'underscore',
    'backbone',
    'main2','alertify',
    'text!templates/user/albumsTemplate.html',
    'views/user/UserAlbumListView',
    'models/user/UserModel',
    'models/user/PhotoModel',
    'views/user/UserVisualsFriendsSubView'
], function ($, _, Backbone, main2,alertify, template, UserAlbumListView,UserModel,PhotoModel,UserVisualsFriendsSubView) {

    return Backbone.View.extend({
        el: $("#content"),

        initialize: function (attrs) {
            var that = this;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    window.id = attrs;
                    $(this.el).unbind("click");
                    that.user = new UserModel({id: response.authResponse.accessToken});
                    that.user.fetch({
                        success: function (user, response) {
                            console.log(response);
                            that.user = response;

                        },
                        error: function (user, response) {
                            console.log("error");

                        }});

                    that.photosSaved = [];
                    that.collection = new PhotoModel({id:response.authResponse.accessToken});
                    that.collection.fetch({
                        success: function (model, response) {
                            console.log(response);
                            for(var i=0;i<response.length;i++) {
                                var name = null;
                                if(response[i].image)name = response[i].image.name;
                                that.photosSaved[response[i].id_photo] = {"value": response[i].value,
                                    "logo": name};
                            }
                            that.render2();
                        },
                        error: function (model, response) {
                            console.log(response);
                            for(var i=0;i<response.length;i++)
                                that.photosSaved[response[i].id_photo] =  {"value":response[i].value,
                                    "logo":response[i].image.name};
                            that.render2();
                        }
                    });
                }
            });
        },
        events: { "click .uploadPhotoUser": "uploadPhotoUser",
        "click .promptMultiplier" : "promptMultiplier"},
        uploadPhotoUser: function (e) {
            e.preventDefault();
            console.log(this.allPhotos);
            var that = this;
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    getTarget(e).disabled = true;
                    $(getTarget(e)).html("Uploading...");
console.log(response);

                    var dataImg = that.allPhotos[getTarget(e).parentNode.id.substring(1)];
                     var data = {
                        access_token: response.authResponse.accessToken,
                        id_photo: dataImg.id_photo,
                        "source": dataImg.source,
                        "date": dataImg.date,
                        "comments": dataImg.comments,
                        "likes": dataImg.likes
                    };

                    this.model = new PhotoModel(data);

                    var success = function (response){
                        var div  = getTarget(e).parentNode.parentNode;

                        $(div).find(".promptMultiplier").html("<img src='../imgs/visuals_red.png'><div style='float:left;color:#fff;width:30px;text-align:center;position:relative;right:-34px;top:6px;'>"+response[0].value+"</div>");
                        $(div).find(".promptMultiplier").prop('title',"Visuals earned from this photo");
                        $(div).find(".promptMultiplier").css('cursor', 'default');
                        $(div).find(".promptMultiplier").removeClass('promptMultiplier');

                        if(response[1])
                            $(div).find(".logo").html(response[1]);
                        $(getTarget(e).parentNode).css('visibility', 'hidden');
                        var currentValue = parseInt($("#coins").text(),10);
                        $("#coins").html(currentValue+response[0].value);
                        alertify.success("Congratulations! You win "+response[0].value+" visuals!");
                        alertify.confirm("Would you like to share this photo in our fans page?", function (e) {
                                postToFeed(response,e);
                        });
                    };

                    this.model.save({}, {
                        success: function (model, response) {
                            console.log(response);
                            success(response);
                        },
                        error: function (model, response) {
                            // prompt dialog
                            alertify.prompt("Sorry, NO logo detected. Can you specify which logo appears?", function (ok, str) {

                                if (ok) {
                                    data["logo"]=str;
                                    this.model = new PhotoModel(data);
                                    this.model.save({}, {
                                        success: function (model, response) {
                                            console.log(response);
                                            success(response);


                                        },
                                        error: function (model, response) {
                                            getTarget(e).disabled = false;
                                            $(getTarget(e)).html("Upload photo");
                                            console.log(response);
                                        }
                                    });
                                }
                            }, "");

                            console.log(response);
                            getTarget(e).disabled = false;
                            $(getTarget(e)).html("Upload photo");
                            /*var responseObj = $.parseJSON(response.responseText);
                            alertify.error(responseObj.error);
                            console.log(response);*/
                        }
                    });
                }
                });
        },
        promptMultiplier :function (e){
            e.preventDefault();
            alertify.log("Estimated value of the picture if it contains a brand", 0, 5000);
        },
        render2: function () {
            var that = this;
            that.allPhotos = [];
            console.log(this.user);
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {

                    function loadPhotos(response) {
                        var photos = [];
                        //var photoModel = [];
                        for (var i = 0; i < response.data.length; i++) {
                            var likes = 0, comments = 0, value=null, logo='?';
                            if (response.data[i].likes != undefined)
                                likes = response.data[i].likes.data.length;
                            if (response.data[i].comments != undefined)
                                comments = response.data[i].comments.data.length;
                            if(that.photosSaved && that.photosSaved[response.data[i].id])
                                value = that.photosSaved[response.data[i].id].value;
                            if(that.photosSaved && that.photosSaved[response.data[i].id] && that.photosSaved[response.data[i].id].logo)
                                logo = that.photosSaved[response.data[i].id].logo;

                            //FORMULA MULTIPLIER
                           /* var pointsLike = Math.min(1,Math.floor(likes/10));
                            var pointsComments = Math.min(2,Math.floor(comments/10));
                            var pointsFriends = Math.min(2,Math.floor(that.user.friends/100));
                            var multi = Math.max(pointsLike+pointsComments+pointsFriends,1);
*/

                            var visuals=Math.round((that.user.friends/500+likes/36+comments/36)*12.5);

                            //Saving info in case of upload photo
                            that.allPhotos[response.data[i].id]= {
                                "id_photo": response.data[i].id,
                                "source": response.data[i].source,
                                "comments": comments,
                                "likes": likes,
                                "date": response.data[i].created_time
                            };
                            photos.push({"likes": likes, "comments": comments, "id": response.data[i].id, "source": response.data[i].source, "visuals": visuals, "value": value, "logo": logo});
                        }

                        var albumListView = new UserAlbumListView({ collection: photos});
                        albumListView.render();
                    }

                    var offset = 0;
                    function initPhotos(id) {
                        if (offset === 0) {
                            var scrollHandler = function () {
                                if ($(window).scrollTop() + $(window).height() > $(document).height() - 300) initPhotos(id);
                            };

                            $(window).scroll(scrollHandler);
                            $(window).on('hashchange', function () { //Scroll off when page changes
                                $(window).off("scroll", scrollHandler);
                            });
                        }
                        if (id === 'tagged') {
                            FB.api('me/photos?limit=12&offset=' + offset, function (response) {
                                console.log(response);
                                if (response.data.length == 0)$(window).off("scroll", scrollHandler);
                                else loadPhotos(response);
                            });
                        }
                        else {
                            console.log(id + '/photos?limit=12&offset=' + offset);
                            FB.api(id + '/photos?limit=12&offset=' + offset, function (response) {
                                console.log(response);
                                if (response.data.length == 0)$(window).off("scroll", scrollHandler);
                                else loadPhotos(response);
                            });
                        }
                        offset += 12;
                    }

                    $("#content").html(template);
                    initMenuUser("#menu-albums");
                    console.log(2);
                    new UserVisualsFriendsSubView();
                    var link = "#album/"+window.id;
                    if (window.id === 'tagged') {
                        FB.api('me/photos?fields=id&limit=200', function (response) {
                            console.log(response);
                            $(".row").html('<div class="span3" style="width:33%;float:left;"></div><div style="width:33%;float:left;text-align:center" class="color">Tagged Photos</div><div style="float:right;text-align:right">' + response.data.length + ' Photos</div><div style="clear:both;margin-bottom:20px"></div>');
                            $("#album").html("<a href="+link+">Tagged photos</a>");
                            initPhotos(window.id);
                        });
                    }
                    else {
                        FB.api(window.id + '?fields=count,name', function (response) {
                            $(".row").html('<div class="span3" style="width:33%;float:left;"></div><div style="width:33%;float:left;text-align:center;overflow:hidden" class="color">' + response.name + '</div><div style="float:right;text-align:right">' + response.count + ' Photos</div><div style="clear:both;margin-bottom:20px"></div>');
                            $("#album").html("<a href="+link+">"+response.name+"</a>");
                            initPhotos(window.id);
                        });
                    }
                }
                else {
                    alertify.error("You are not logged in");
                    window.location = "#home";
                }
            });
        }
    });
});