define([
    'jquery',
    'underscore',
    'backbone',
    'main2', 'alertify',
    'text!templates/user/albumsTemplate.html',
    'views/user/UserAlbumsListView',
    'models/user/UserModel',
    'views/user/UserVisualsFriendsSubView'
], function ($, _, Backbone, main2, alertify, template, UserAlbumsListView, UserModel, UserVisualsFriendsSubView) {

    return Backbone.View.extend({
        el: $("#content"), initialize: function () {
            $(this.el).unbind("click");
        },
        render: function () {
            console.log("a");
            FB.getLoginStatus(function (response) {
                if (response.status === 'connected') {
                    function getAlbums() {
                        FB.api('/me/albums?fields=id,count,name,cover_photo', function (response) {

                            var map = new Object();
                            for (var i = 0; i < response.data.length; i++) {
                                map[response.data[i].cover_photo] = {"name": response.data[i].name, "count": response.data[i].count, "id": response.data[i].id}; //Save cover_photo - albumid
                                FB.api('/' + response.data[i].cover_photo + '?fields=source', function (response2) {
                                    var albums = [];
                                    albums.push({"name": map[response2.id].name, "id": map[response2.id].id, "count": map[response2.id].count, "source": response2.source});
                                    var albumsListView = new UserAlbumsListView({ collection: albums});
                                    albumsListView.render();
                                });
                            }
                        });
                    }

                    function loadTagged(id) {
                        FB.api('/me/photos?fields=source', function (response) {
                            var albums = [];
                            if (response.data.length > 0) {
                                console.log(id);
                                FB.api('/fql', {q: "SELECT '' FROM photo_tag WHERE subject= " + id}, function (response2) {
                                    albums.push({"name": "Tagged photos", "count": response2.data.length, "id": "tagged", "source": response.data[0].source});
                                    var albumsListView = new UserAlbumsListView({ collection: albums});
                                    albumsListView.render();
                                })
                            }
                        });
                    }

                    $("#content").html(template);
                    initMenuUser("#menu-albums");
                    new UserVisualsFriendsSubView();

                    getAlbums();
                    loadTagged(response.authResponse.userID);
                }
                else {
                    alertify.error("You are not logged in");
                    window.location = "#home";
                }
            });
        }
    });
});
