module.exports = function (db) {
    var util = require('../util');
    var dao = require('../dao')(db);
    var W = require('when');
    return {

        read: function (req, res) {
            dao.getById(db.Company, req.session.company_id)
                .then(function (company) {
                    if (!company) util.reject("Company not registered with id = " + req.session.company_id);
                    else return dao.findAllWhereInclude(db.SaleLine, {company:company.id }, [
                        { model: db.User, as: 'user2'},
                        {model: db.Product, as: 'product2'}]);
                })
                .then(util.stdSeqSuccess.genFuncLeft(res), util.stdSeqError.genFuncLeft(res))
                .done();
        },
        commit: function (req, res) {
            var attribs = {committed : req.body.committed};

            if (util.validateParams(res, {"company_id": req.session.company_id}) && util.validateParams(res, attribs)) {
                dao.getById(db.Company, req.session.company_id)
                    .then(function (company) {
                        if (!company) util.reject("Company not registered with id = " + req.session.company_id);
                        else return company.getSaleline({ where: {id: req.params.id} });
                    })
                    .then(function (saleline) {
                        if (saleline.length == 0) util.reject("Saleline not exists = " + req.params.id);
                        else return saleline[0].updateAttributes(attribs);
                    })
                    .then(util.stdSeqSuccess.genFuncLeft(res), util.stdSeqError.genFuncLeft(res))
                    .done();
            }
        }
    }
}
;