module.exports = function (db) {
    var util = require('../util');
    var dao = require('../dao')(db);
    var W = require('when');

    return {
        login: function (req, res) {
            util.getUserIdByToken(req.body.access_token)
                .then(function (userID) {
                    if(userID!=req.body.id_facebook)util.reject("What are you trying?")
                    else return dao.User.getByIdFacebook(userID)
                })
                .then(function (user) {
                    var attribs = {"id_facebook": req.body.id_facebook, "name": req.body.name, "email": req.body.email,
                        "first_name": req.body.first_name, "last_name": req.body.last_name, "link": req.body.link,
                        "gender": req.body.gender, "timezone": req.body.timezone,
                        "locale": req.body.locale, "birthday": req.body.birthday, "friends": req.body.friends};
                    console.log("login");
                    if (!user)  return dao.create(db.User, attribs);
                    else return user.updateAttributes(attribs || {"coins": user.coins});
                })
                .then(function (user) {
                    if (user) {
                        req.session.user_id = user.id;
                        return user;
                    }
                    else console.log("user fail");
                })
                .then(util.stdSeqSuccess.genFuncLeft(res), util.stdSeqError.genFuncLeft(res))
                .done();
        },
        logout: function (req, res) {
            if (util.validateParams(res, {"user_id": req.session.user_id})) {
                req.session.destroy();
                util.stdSeqSuccess(res, "Logged out");
            }
        },
        read: function (req, res) {
            console.log(req.params.id);
            util.getUserIdByToken(req.params.id) //ID = access_token
                .then(function (userID) {
                    return W.all([dao.User.getByIdFacebook(userID), userID]);
                })
                .spread(function (user, userID) {
                    if (!user) util.reject("User not registered with id = " + userID);
                    else return user;
                })
                .then(util.stdSeqSuccess.genFuncLeft(res), util.stdSeqError.genFuncLeft(res))
                .done();
        }
    }
};