var express = require('express');
var http = require('http');
var path = require('path');
var cors = require('cors');
var app = express();

app.set('port', process.env.PORT || 3000);
app.set('views', __dirname + '/views');
app.use(express.favicon());
app.use(express.methodOverride());
app.use(express.bodyParser( { uploadDir: __dirname + '/public/tmp' } ));
app.use(express.logger('dev'));
app.use(express.json());
//Aixo si
app.use(express.cookieParser());
app.use(express.session({secret: '1234567890QWERTY', maxAge: Date.now() + (30 * 86400 * 1000)}));

app.use(express.urlencoded());

app.use(cors());
app.use(app.router);
app.use(express.static(path.join(__dirname, 'public')));

Function.prototype.genFuncLeft = function () {
    var fn = this, args = Array.prototype.slice.call(arguments);
    return function () {
        return fn.apply(null, args.concat(Array.prototype.slice.call(arguments)));
    }
};

Function.prototype.genFuncRight = function () {
    var fn = this, args = Array.prototype.slice.call(arguments);
    return function () {
        return fn.apply(null, Array.prototype.slice.call(arguments).concat(args));
    }
};

var db = require('./models')(app);

db.initPromise
    .then(function () {
        //Fa un require de tots els fitxers de /routes - OLD: var opinions = require('./routes/opinions')(db)
        require('fs').readdirSync('./routes/').forEach(function(file) {
            if (file.match(/.+\.js/g) !== null && file !== 'index.js') {

                var name = file.replace('.js', '');
                console.log("routes "+name);
                this[name]=require('./routes/' + name)(db);
            }
        });
        //USER
        app.post('/user', user.login);
        app.get('/user/:id', user.read);
        app.delete('/user', user.logout);

        app.post('/user/photos', photo.create);
        app.get('/user/photos/:id', photo.read);

        //COMPANY
        app.post('/company/login', company.login);
        app.post('/company/logout', company.logout);
        app.post('/company/profile', company.create);
        app.get('/company/profile', company.read);
        app.put('/company/profile/:id', company.update);
       //app.delete('/company/profile', company.delete);

        app.post('/company/products', product.create);
        app.get('/company/products', product.read);
        app.get('/company/products/:id', product.read);
        app.put('/company/products/:id', product.update);
        app.delete('/company/products/:id', product.delete);

        app.post('/company/products/:id/photos', productImage.create);
        app.get('/company/products/:id/photos', productImage.read);
        app.get('/company/products/:id/photos/:idPhoto', productImage.read);
        app.delete('/company/products/:id/photos/:idPhoto', productImage.delete);

        app.post('/company/logos', logo.create);
        app.get('/company/logos', logo.read);
        app.get('/company/logos/:id', logo.read);
        app.delete('/company/logos/:id', logo.delete);

        app.get('/company/sales', saleLine.read);
        app.put('/company/sales/:id', saleLine.commit);


        app.get('/company/photos', photo.readCompany);
        app.get('/company/photos/statistics', photo.readStatistics);
        //SHOP
        app.get('/user/:idUser/shop/products/:id', product.readByCategory);
        app.get('/user/:idUser/shop/products', product.readByCategory);
        app.get('/user/:idUser/shop/product/:id', product.readShop);

        app.post('/user/:idUser/shop/basket', basketLine.create);
        app.get('/user/:idUser/shop/basket', basketLine.read);
        app.get('/user/:idUser/shop/basket/:id', basketLine.read);
        app.delete('/user/:idUser/shop/basket/:id', basketLine.delete);
        app.post('/user/:idUser/proceed', basketLine.proceed);

        //------------------------------------------------------------------
        var port = process.env.OPENSHIFT_NODEJS_PORT || app.get('port');
        var ip = process.env.OPENSHIFT_NODEJS_IP || "127.0.0.1";
        http.createServer(app).listen(port, ip, function () {console.log("Express server listening on " + ip + ":" + port);})
    },
    function (err) {console.log("Error initializing database: " + err);})
    .done();
